SystemOrganization addCategory: #'Summer2010-STdoc'!
SystemOrganization addCategory: #'Summer2010-Morph'!
SystemOrganization addCategory: #'Summer2010-Poland'!
SystemOrganization addCategory: #'Summer2010-BublingMorpg'!
SystemOrganization addCategory: #'Summer2010-JumpingJack'!

PolygonMorph subclass: #Liaison
	instanceVariableNames: 'source destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!Liaison methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:38'!
delete
	
	super delete.
	self source isNil
	ifFalse:[self source linesCollection remove: self].
	
	self destination isNil
	ifFalse:[self destination linesCollection remove: self].! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
destination
	^ destination! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:01'!
destination: aMyRoundedMorph
	destination := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/17/2010 05:14'!
draw
	super delete.
	self vertices: {self source center. self destination center}
			color: Color black borderWidth: 2 borderColor: (Color black).
	self openInWorld.
	self passivate.! !

!Liaison methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/15/2010 13:12'!
initialize

	super initialize.
	self beSticky.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
source
	^ source! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:29'!
source: aMyRoundedMorph
	source := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/17/2010 03:17'!
step

	self source isNil | self destination isNil
	ifFalse: [self draw].! !

!Liaison methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/17/2010 02:55'!
stepTime
	^ 250.! !

Morph subclass: #JumpingJack
	instanceVariableNames: 'string isMovingLeft isMovingRight isMovingUp isMovingDown distance jumpingIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:48'!
displayedMorphs
	|result|
	
	result := OrderedCollection new.
	World submorphs do: 
		[:each| 
				each isInWorld 
					ifTrue: [result add: each]].
										
	^result.! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:47'!
distance
	^ distance! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:47'!
distance: anObject
	distance := anObject! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 22:56'!
falling: ceil
	self bottom + (self distance) < ceil & self isMovingUp not
		ifTrue: [ 
			| aPoint width height |
			self bottom: self bottom + (self distance) ]
		ifFalse: [ self bottom: ceil ].
		
		self bottom = ceil & self isMovingDown
		ifTrue: [ self bottom: (self bottom+1)].
		
	self isMovingDown: false. ! !

!JumpingJack methodsFor: 'events-processing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:13'!
handleEvent: anEvent
	"Handle the given event"

	anEvent isMouse
		ifTrue: [ 
			anEvent isMouseOver | anEvent isDraggingEvent
				ifTrue: [
					self stopStepping.
					self keepFocus ]
				ifFalse: [ self startStepping ] ].
	anEvent isKeyboard
		ifTrue: [self keyPressed: anEvent keyValue ].
	^ anEvent sentTo: self! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:08'!
incrJumpingIndex

	self jumpingIndex: (self jumpingIndex  + 1)! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:08'!
incrJumpingIndex: anInteger

	self jumpingIndex: (self jumpingIndex  + anInteger)! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/21/2010 23:04'!
initialize 

	super initialize.
	self bounds: (100@100 corner: 150@200).
	self string: (MyOtherTextFieldMorph new with: ' ' container: self).
	self string
		topLeft: (self topLeft);
		width: 1;
		height: 1;
		color: self color;
		setTextColor: self color;
		borderColor: self color.
		
	isMovingLeft := false.
	isMovingRight := false.
	isMovingUp := false.
	isMovingDown := false.
	
	distance := 10.
	jumpingIndex := 0.! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:56'!
interistingMorphs
	|result|
	
	result := OrderedCollection new.
	self displayedMorphs do:
	[:each |
		((self right) > (each left)) & ((self left) < (each right)) & (each top >= self bottom)
			ifTrue:[ result add: each]].
	^ result.! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingDown
	^ isMovingDown! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:53'!
isMovingDown: anObject
	isMovingDown := anObject.
	anObject
		ifTrue:[self isMovingUp: false]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingLeft
	^ isMovingLeft! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:52'!
isMovingLeft: anObject
	isMovingLeft := anObject.
	anObject
		ifTrue:[self isMovingRight: false]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingRight
	^ isMovingRight! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:52'!
isMovingRight: anObject
	isMovingRight := anObject.
	anObject
		ifTrue:[self isMovingLeft: false]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingUp
	^ isMovingUp! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:53'!
isMovingUp: anObject
	isMovingUp := anObject.
	anObject
		ifTrue:[self isMovingDown: false]! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:31'!
jumping: ceil

	(self isMovingUp) & (self jumpingIndex = 0)
		ifTrue: [
			self jumpingIndex: 1.
			self isMovingUp: false].
	
	self jumpingIndex > 0
		ifTrue: [
			self incrJumpingIndex.
			self jumpingIndex < 11 & self isMovingDown not
				ifTrue:[self bottom: (self bottom - (2 * self distance))]].
		
	self bottom = ceil
		ifTrue:[self jumpingIndex: 0]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:04'!
jumpingIndex
	^ jumpingIndex! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:04'!
jumpingIndex: anObject
	jumpingIndex := anObject! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:31'!
keepFocus
	self string keyboardFocusChange: true! !

!JumpingJack methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 6/21/2010 22:42'!
keyPressed: aKeyValue
	"28 : left
	 29 : right
	 30 : up
	 31 : down"
	
	aKeyValue = 28
		ifTrue:[self isMovingLeft: true].
	aKeyValue = 29
		ifTrue:[self isMovingRight: true].
	aKeyValue = 30
		ifTrue:[self isMovingUp: true].
	aKeyValue = 31
		ifTrue:[self isMovingDown: true].! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:00'!
moveLeft

	self isMovingLeft
		ifTrue:[
			self left - self distance > World left 
				ifTrue:  [self right: (self right - self distance)]
				ifFalse: [self left: World left].
			self isMovingLeft: false].! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:01'!
moveRight

	self isMovingRight
		ifTrue:[
			self right + self distance < World right 
				ifTrue:  [self right: (self right + self distance)]
				ifFalse: [self right: World right].
			self isMovingRight: false].! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:54'!
nearestMorph
	|max temp|
	
	temp := self interistingMorphs.
	temp isEmpty
	ifTrue: [^World].
	max := temp first.
	temp do:
	[:each | 
		(each top < max top)
		ifTrue:[max := each]].
	
	^ max.! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/21/2010 22:18'!
openInWorld
	
	super openInWorld.
	self string isNil
	ifFalse:[	
			self string openInWorld .
			self addMorphFront: (self string)].
		
	^self.! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:29'!
step
	|morph ceil |
	self isMovingDown
		ifTrue: [ 
			self distance: 20]
		ifFalse: [ self distance: 10 ].
	morph := self nearestMorph.	"self halt."
	morph = World
		ifTrue: [ ceil := World bottom ]
		ifFalse: [ ceil := morph top ].
		
	self falling: ceil.
	self moveRight.
	self moveLeft.
	self jumping: ceil.! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:18'!
stepTime 
	^25.! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:17'!
string
	^ string! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:17'!
string: anObject
	string := anObject! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:19'!
with: aPoint

	self topLeft: aPoint.

! !

TestCase subclass: #CalcTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Poland'!

!CalcTest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 13:03'!
testExecute

	self assert:[ (Calc execute: '+') = Calc error].
	self assert:[ (Calc execute: '3') = '3'].
	self assert:[ (Calc execute: '3 2 +') = '5'].
	self assert:[ (Calc execute: '3 2 + *') = Calc error].
	self assert:[ (Calc execute: '3 3 2 + *') = '15'].! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 16:16'!
testExecute2

	self assert:[ (Calc execute2: '+') = Calc error].
	self assert:[ (Calc execute2: '3') = '3'].
	self assert:[ (Calc execute2: '3 2 +') = '5'].
	self assert:[ (Calc execute2: '3 2 + *') = Calc error].
	self assert:[ (Calc execute2: '3 3 2 + *') = '15'].! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 12:54'!
testFinfFirstOperator

	self assert:[ (Calc findFirstOperator: #('3' '2' '+')) = 3].
	self assert:[ (Calc findFirstOperator: #('3' '3' '2' '+' '*')) = 4].
	self assert:[ (Calc findFirstOperator: #('3 2')) = Calc error].
	self assert:[ (Calc findFirstOperator: #('3 +')) = Calc error].! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 16:16'!
testParseStack

	self assert:[ (Calc parseStack: #('3' '2' '+')) = '5 '].
	self assert:[ (Calc parseStack: #('3' '3' '2' '+' '*')) = '3 5 * '].
	self assert:[ (Calc parseStack: #('3' '+')) = Calc error].
	self assert:[ (Calc parseStack: #('3' '2')) = Calc error].! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 12:43'!
testReturn

	self assert:[ (Calc return: '3') = '3'].
	self assert:[ (Calc return: '-') = Calc error].
	self assert:[ (Calc return: 'name:') = Calc error].! !

TextMorphForFieldView subclass: #MyOtherTextMorphForFieldView
	instanceVariableNames: 'sender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!MyOtherTextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
handleKeystroke: anEvent
	"System level event handling."

	| pasteUp |
	self sender container keyPressed: (anEvent keyValue) .
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:
		["Allow passing through text morph inside pasteups"
		(self wouldAcceptKeyboardFocusUponTab and:
				[(pasteUp := self pasteUpMorphHandlingTabAmongFields) notNil])
			ifTrue:[^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !

!MyOtherTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
sender
	^ sender! !

!MyOtherTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
sender: anObject
	sender := anObject! !

!MyOtherTextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
with: aClass

	self sender: aClass.! !

TextMorphForFieldView subclass: #MyTextMorphForFieldView
	instanceVariableNames: 'sender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyTextMorphForFieldView methodsFor: 'events-processing' stamp: 'BenjaminVanRyseghem 6/18/2010 15:03'!
handleKeystroke: anEvent
	"System level event handling."

	| pasteUp |
	self sender resize.
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:
		["Allow passing through text morph inside pasteups"
		(self wouldAcceptKeyboardFocusUponTab and:
				[(pasteUp := self pasteUpMorphHandlingTabAmongFields) notNil])
			ifTrue:[^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
sender
	^ sender! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
sender: anObject
	sender := anObject! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
with: aClass

	self sender: aClass.! !

BorderedMorph subclass: #MyRoundedMorph
	instanceVariableNames: 'stringMorph linesCollection refresh margeX margeY'
	classVariableNames: 'CanMakeAChild'
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:31'!
addLine: aLiaison.

	self linesCollection add: aLiaison.
	aLiaison openInWorld.
	self addMorphBack: aLiaison! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/20/2010 01:40'!
canIPutAChildHere: aRectangle
	|list|
	
	list := OrderedCollection new.
	self class allInstances do:[:each |
		((each bounds containsPoint: aRectangle topLeft) 		|
		(each bounds containsPoint: aRectangle topRight) 		|
		(each bounds containsPoint: aRectangle bottomLeft)	|
		(each bounds containsPoint: aRectangle bottomRight)) &
		((each = self) not)
		ifTrue:[list add: each]].

^list isEmpty.



! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:28'!
delete
	
	self deleteLines.
	self stringMorph isNil
		ifFalse:[	self stringMorph delete ].
	super delete.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 20:33'!
deleteLines
	|tempList|
	
	tempList := OrderedCollection new.
	self linesCollection collect:[:each| tempList add: each ].
			
	tempList do:[:each|
		each source = self
		ifTrue: [each destination delete]
		ifFalse: [each delete]]! !

!MyRoundedMorph methodsFor: 'events-processing' stamp: 'BenjaminVanRyseghem 6/18/2010 20:21'!
handleEvent: anEvent
	"Handle the given event"
	
	anEvent isMouse
	ifTrue:[
			anEvent isDraggingEvent
			ifTrue:[self linesStartStepping]
			ifFalse:[self linesStopStepping].
			anEvent blueButtonPressed
				ifTrue: [
					CanMakeAChild
					ifTrue:[self makeAChild].
					CanMakeAChild := false]
				ifFalse:[CanMakeAChild := true]].
	
	
	
	
	^anEvent sentTo: self.! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/18/2010 20:21'!
initialize 

	super initialize .
	self useRoundedCorners.
	margeX := 10.
	margeY := 15.
	linesCollection := OrderedCollection new.
	CanMakeAChild := true.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection
	^ linesCollection! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection: anObject
	linesCollection := anObject! !

!MyRoundedMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStartStepping

	self linesCollection do:[:each| each startStepping].! !

!MyRoundedMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStopStepping

	self linesCollection do:[:each| each stopStepping].! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:13'!
makeAChild
	|child childLabel childPoint childColor|
	
	childLabel := self stringMorph text, '''s child'.
	childPoint := ((self bottomRight x) + 75)@((self bottomRight y) + 75).
	childColor := self color lighter lighter lighter lighter .
	
	child := self class new with: childLabel where: childPoint color: childColor.
	child openInWorld.
	
	Liaison new source: self; destination: child; draw; openInWorld.! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/18/2010 20:23'!
openInWorld 

	super openInWorld.
	self stringMorph isNil
	ifFalse:[	
			self stringMorph openInWorld .
			self addMorphFront: (self stringMorph)].
	^ self.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:32'!
resize
	| width height aPoint |
		
	aPoint := self topLeft.
	
	self stringMorph topLeft: ((aPoint x+margeX)@(aPoint y+margeY)).
	
	width := self stringMorph width + (2 * margeX).
	height := self stringMorph height + (2 * margeY).
	
	self 	bounds: (aPoint corner: ((aPoint x+width)@(aPoint y+height))).! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/20/2010 01:45'!
setPosition: point width: width height: height
	| block |
	block := [ 
		self stringMorph topLeft: (point x + margeX) @ (point y + margeY).
		self bounds: (point corner: (point x + width) @ (point y + height))].
	
	block value.
	
	[ self canIPutAChildHere: self bounds ]
		whileFalse: [ 
			point setX: point x + width setY: point y.
			block value ]! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph
	^ stringMorph! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph: anObject
	stringMorph := anObject! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/20/2010 01:44'!
with: aString where: aPoint color: aColor
	| width height point |
	self
		topLeft: aPoint;
		color: aColor.
	point := aPoint.
	self stringMorph: (MyTextFieldMorph new with: aString container: self).
	width := self stringMorph width + (2 * margeX).
	height := self stringMorph height + (2 * margeY).
	self setPosition: point width: width height: height.! !

PluggableTextFieldMorph subclass: #MyOtherTextFieldMorph
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
container
	^ container! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
container: anObject
	container := anObject! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new with: self;
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!MyOtherTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MyOtherTextMorphForFieldView! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
vIsScrollbarNeeded

	^false.! !

!MyOtherTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:20'!
with: aString container: aContainer
	|aPoint aColor|
	
	self container: aContainer.

	aPoint := self container topLeft.
	aColor := self container color.

	self
		setText: aString;
		width: ((self text asMorph width) +20);
		height: 8;
		borderColor: aColor;
		color: aColor negated;
		setTextColor: aColor.
		
! !

PluggableTextFieldMorph subclass: #MyTextFieldMorph
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:20'!
accept

	self setText: self text.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:33'!
container
	^ container! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:33'!
container: anObject
	container := anObject! !

!MyTextFieldMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:04'!
delete

	self initialize.
	super delete.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:31'!
resize
	|aPoint aString |
	aPoint := self container topLeft.

	self
		width: ((self text asMorph width) +20).
		
	self container resize.! !

!MyTextFieldMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new with: self;
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!MyTextFieldMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/18/2010 04:58'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MyTextMorphForFieldView! !

!MyTextFieldMorph methodsFor: 'scrolling' stamp: 'BenjaminVanRyseghem 6/18/2010 04:48'!
vIsScrollbarNeeded

	^false.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 20:18'!
with: aString container: aContainer
	|aPoint aColor|
	
	self container: aContainer.

	aPoint := self container topLeft.
	aColor := self container color.

	self
		setText: aString;
		width: ((self text asMorph width) +20);
		height: 8;
		borderColor: aColor;
		color: aColor negated;
		setTextColor: aColor.
		
! !

Object subclass: #Calc
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Poland'!

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 06:37'!
error

	^ 'An error occured'.! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 13:36'!
execute2: aString
	|stack newString tmp|
	
	aString = Calc error
	ifTrue: [^aString].
	stack := (aString subStrings: ' ') asOrderedCollection.
	stack isEmpty
	ifTrue:[^aString].
	stack size = 1
	ifTrue: [
		tmp := self return: stack first.
		Transcript show: tmp;cr.
		^tmp].

	self new with: stack; reduceStack.! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 15:53'!
execute: aString
	|stack newString tmp|
	
	aString = Calc error
	ifTrue: [^aString].
	stack := aString subStrings: ' '.
	stack isEmpty
	ifTrue:[^aString].
	stack size = 1
	ifTrue: [
		
		tmp := self return: stack first.
		Transcript show: tmp;cr.
		^tmp].
	
	self execute: (self parseStack: stack).! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 12:50'!
findFirstOperator: aStack
	|index|
	index := 1.
	
	[index <= aStack size and: [(aStack at: index) numArgs = -1]]
		whileTrue: [index := index +1].
	
	^index = (aStack size + 1)
		ifTrue: [self error]
		ifFalse: [index]
	! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 16:15'!
parseStack: aStack
	|index numberOfArguments operator result|
			
	index := self findFirstOperator: aStack.
	index= Calc error
		ifTrue: [^index].
		
	operator := aStack at: index.
	numberOfArguments := 1 + operator numArgs.
	result := ''.
	
	"TO CHANGE"
	(1 to: (index-numberOfArguments-1)) do: [:i| result := result, (aStack at: i), ' '].

	numberOfArguments = 1 & (aStack size >= (numberOfArguments+1))
		ifTrue: [result := result, ((aStack at: index-1) asNumber perform:((aStack at: index) asSymbol)) asString, ' '].

	numberOfArguments > 1 & (aStack size >= (numberOfArguments+1))
		ifTrue: [
			|args|
			args := OrderedCollection new.
			aStack collect: [:each| args add: (each asNumber)] from: index-numberOfArguments+1 to: index-1.
			result := result, ((aStack at: (index-numberOfArguments)) perform:((aStack at: index) asSymbol) withArguments: (args asArray)) asString, ' ']
		ifFalse: [^Calc error].
	
	(index+1 to: (aStack size)) do: [:i| result := result, (aStack at: i), ' '].

	^ result.
! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 05:29'!
return: aString

	aString numArgs < 1
		ifTrue:[^aString]
		ifFalse: [^self error]
	! !

!Calc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 05:36'!
reduceStack
	|index receiver args operator numberOfArgs|
	
	self stack size = 1
		ifTrue:[self halt.^self class return: self stack first].
	
	index := self class findFirstOperator: self stack.
	operator := self stack at: index .
	numberOfArgs := 1 + (operator numArgs).
	
	receiver := (self stack at: (index - numberOfArgs)) asNumber.
	args := OrderedCollection new.
	self stack collect: [:each| args add:(each asNumber)] from: (index - numberOfArgs + 1) to: (index - 1).
	
	numberOfArgs = 1
	ifTrue: [self stack at: index put: (receiver perform: operator asSymbol) asString.]. 
	
	numberOfArgs > 1
	ifTrue: [self stack at: index put: (receiver perform: operator asSymbol with: args) first asString].
	self stack collect: [:each| self stack remove:each] from: (index - numberOfArgs + 1) to: (index - 1).
	self stack remove: receiver asString.
	self reduceStack.! !

!Calc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
stack
	^ stack! !

!Calc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
stack: anObject
	stack := anObject! !

!Calc methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
with: aStack

	self stack: aStack.! !

Object subclass: #MorphFire
	instanceVariableNames: 'tableau taille dissipation sleepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 16:53'!
delete
	(1 to: tableau size) do:
	[:i|
		(1 to: (tableau at: 1) size) do:
		[:j|
			((tableau at: i) at: j) delete.
		]
	
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation
	^ dissipation! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation: anObject
	dissipation := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 20:13'!
drawFlame
| blockClosure clockProcess |

blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

        (tableau size) timesRepeat: 
							[self initColor.
							 self majColor.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:40'!
drawFlame2
| blockClosure clockProcess |
self initColor .
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

         (tableau size) timesRepeat: 
							[self majColor2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:55'!
drawFlames
| blockClosure clockProcess |
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := 2 * self sleepTime.

        (tableau size) timesRepeat: 
							[self drawFlame2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:46'!
initColor
	|ligne median start|
	
	median := (((tableau at:1) size)*0.8)asInteger.
	start := ((tableau at:1) size) - median.
	
	Transcript show: 'start : ', start asString ; cr.
	Transcript show: 'median : ', median asString ; cr.
	
	ligne := tableau at: (tableau size).
	(1 to: start) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].
	(start to: median+start) do:
	[:i|
		(ligne at:i) color:(Color r: ( Random new nextValue / 1000000000 -1)g: 0 b:0);hide.	
	].
	(median+start to: ligne size) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:59'!
initialize
	|nblignes nbcolonnes initX initY tempX tempY|

	nblignes := 50.
	nbcolonnes := 100.
	self taille: 1.
	
	initX := 50.
	initY := 50.
	self dissipation: 0.95.
	self sleepTime: 500.
	
	tableau := Array new: nblignes. "colone"
	(1 to: nblignes) do:
	[:i|
		tableau at: i put: (Array new: nbcolonnes).	 "ligne"
	].

	(1 to:  nblignes) do:
	[:col|
		(1 to: nbcolonnes) do:
		[:lig|
			tempX := (initX + (taille*lig)).
			tempY := (initY + (taille*col)).
			(tableau at: col) at: lig put: (Morph new bounds: ((tempX@tempY) corner: (tempX + taille)@ (tempY + taille))).
			((tableau at: col) at: lig) dragEnabled: false;openInWorld.
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:57'!
majColor
|ligne moy diss seuil|

	seuil := 0.15.

	diss := self dissipation.

	(1 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2)) color red)/3.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1))) color red)/3.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		((ligne at:1) color red) +  ((ligne at:1) color blue)  + ((ligne at:1) color green) < seuil
		ifTrue:[(ligne at:1) hide]
		ifFalse:[(ligne at:1)show].
		
		((ligne at:(ligne size)) color red) +  ((ligne at:(ligne size)) color blue) + ((ligne at:(ligne size)) color green) < seuil
		ifTrue:[(ligne at:(ligne size)) hide]
		ifFalse:[(ligne at:(ligne size))show].
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := ((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + ((((tableau at:i+1) at: j+1)) color red)/3.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
			((ligne at:j) color red) +  ((ligne at:j) color blue) + ((ligne at:j) color green) < seuil
		ifTrue:[(ligne at:j) hide]
		ifFalse:[(ligne at:j)show].
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:41'!
majColor2
|ligne moy diss|

	diss := self dissipation.

	(2 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2) color red) + (((tableau at:i) at: 2) color red) + (((tableau at:i-1) at: 1) color red) + (((tableau at:i-1) at: 2) color red))/8.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1) ) color red) + (((tableau at:i-1) at: ((tableau at:i-1) size) ) color red)+ (((tableau at:i-1) at: ((tableau at:i-1) size-1) + (((tableau at:i) at: ((tableau at:i) size-1) ) color red)) color red))/8.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := (((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + (((tableau at:i+1) at: j+1) color red) + (((tableau at:i) at: j-1) color red) + (((tableau at:i) at: j+1) color red) + (((tableau at:i-1) at: j-1) color red) + (((tableau at:i-1) at: j) color red)+ (((tableau at:i-1) at: j+1) color red))/8.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
		]
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime
	^ sleepTime! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime: anObject
	sleepTime := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:55'!
step
"|i|
	i isNil
	ifTrue: [i:=0] ifFalse: [i:=i+1]."
	self initColor.
	self majColor.
	"self majColor2."
	"i > 50
	ifTrue:[self majColor2]."! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 15:51'!
stepTime
	^self sleepTime.! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille
	^ taille! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille: anObject
	taille := anObject! !

Object subclass: #STdoc
	instanceVariableNames: 'class stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-STdoc'!

!STdoc commentStamp: 'BenjaminVanRyseghem 6/10/2010 15:23' prior: 0!
Un STdoc est un simili Javadoc.!

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:46'!
commentsFrom2: aMethod
	"Return the first comment of a method"
	"self commentsFrom2: (Point>>#dist:)"
	^ aMethod methodClass firstCommentAt: aMethod selector.
	
	! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
commentsFrom: aMethod
	"Return the first comment of a method"

	|source result boolWriting boolFirstComment start|
	source := aMethod getSource asString.
	result := ''.
	boolWriting := false.
	boolFirstComment := true.
	start := ((source lineNumber: 1) size +1).
	
	( start to: source size) do:
		[:i|
			(source at: i) = $"
				ifTrue: 
					[
						boolWriting 
							ifTrue: [boolWriting := false]	
							ifFalse: 
							[
								boolFirstComment 
									ifTrue: 
									[
										boolFirstComment := false.
										boolWriting := true.
									]						
							]
					]
				ifFalse: 
					[
						boolWriting
							ifTrue: [result := result, ((source at: i) asString)]
							ifFalse: 
							[
								(source at: i) isSeparator
								ifFalse:
								[
									boolFirstComment := false.
									
								]
							]
					]
		].
	^result withCRs.! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
nameOf: aMethod
	"Return the name of method"
	"self  nameOf: (Point>>#dist:)"
	
	^ aMethod selector
	"
	|source result boolWriting|
	source := (aMethod name subStrings: '>>' ) at: 2.
	result := ''.
	boolWriting := true.
	
	(1 to: source size-1) do:
		[:i|
			((source at: i+1) asString ) = ''
				ifTrue: [boolWriting := false]
				ifFalse: [boolWriting 
								ifTrue: [result := result, ((source at: i) asString)] 
								ifFalse: []
				]
		
		].
	^result. "! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:52'!
new

	^ super new initialize ! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/13/2010 15:38'!
build

	self displayHeader.
	self displayInstanceVariables.
	self displayClassVariables.
	self displayInstanceMethods.
	self displayClassMethods. 
	self displaySuperClass. 
	self displaySubClasses.
	^self stream contents! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
classMethods
	^self myclass class methods.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:37'!
classVariables
	^self myclass classVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:15'!
comment

	^self myclass class comment.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:23'!
displayClassMethods

	self classMethods isEmpty
		ifFalse: [
			self stream nextPutAll: '----------------------------------------------';cr.
			self stream nextPutAll: 'Mthodes d''instance :';cr.
			self classMethods do: [:each|
				self stream nextPutAll:'     '; nextPutAll:(self class nameOf: each);cr.
				(self class commentsFrom: each) isEmpty
					ifTrue: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:('Just another uncommented method');cr;cr.] 
					ifFalse: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:(self class commentsFrom: each);cr;cr]]].
						
					
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:23'!
displayClassVariables
	
	self classVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------';cr.
		self stream nextPutAll: 'Variables de classe :'; cr.
		self classVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayHeader
	self stream nextPutAll: self name; cr.
	self stream nextPutAll: self comment;cr;cr.
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayInstanceMethods

	self instanceMethods size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Mthodes d''instance :'; cr.
		self instanceMethods do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll:(STdoc nameOf: each); cr.
			(STdoc commentsFrom: each) = ''
			ifTrue: 
			[
				self stream nextPutAll: '     '; nextPutAll:('Just another uncommented method');cr;cr.
			] 
			ifFalse: 
			[
				self stream nextPutAll: '     '; nextPutAll:(STdoc commentsFrom: each);cr;cr.
			].
			
		]
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayInstanceVariables
	
	self instanceVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Variables d''instance :';cr.
		self instanceVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displaySubClasses
	
	self subClasses size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'SubClasses :'; cr.
		"self subClasses do:
		[:each|
			result := result, '     ',each name, String cr.
			result := result, '     ',('Afficher la doc: (STdoc new with: ',each name,';build)'), String cr, String cr.
		]."
		
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displaySuperClass
	
	self superClass isNil
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Superclass :'; cr.
		self stream nextPutAll: '     '; nextPutAll: (self superClass name); cr.
		"result := result, '     ',('Afficher la doc: (STdoc new with: ',self superClass name,';build)'), String cr, String cr."
	].
	^self.! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:18'!
export

	self export: ((self name),'.txt').! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:17'!
export: aString
	|temp|
	temp := self build.
	StandardFileStream 
	fileNamed: aString
	do:[:str|str nextPutAll: temp.]! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:35'!
initialize

stream := WriteStream on: String new.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:22'!
instanceMethods
	^self myclass methodDict values.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
instanceVariables
	^self myclass instVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:06'!
myclass
	^ class
! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:25'!
myclass: anObject
"Setter"
	class := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:13'!
name

	^self myclass name.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream
	^ stream! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream: anObject
	stream := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
subClasses
	^self myclass subclasses.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
superClass
	^self myclass superclass.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:04'!
with: aClass 

class := aClass .! !
